@echo off

rem ESMPRO/SM
set ESMPRO_Key="HKLM\SOFTWARE\Wow6432Node\NEC\ESMSM"
set ESMPRO_CurrentVersion="6.44"

rem DPM
set DPM_Key="HKLM\SOFTWARE\Wow6432Node\NEC\DeploymentManager"
set DPM_VersionInformation="6.90"

rem Sysmon
set Sysmon_Key="HKLM\SOFTWARE\Wow6432Node\NEC\RMP"
set Sysmon_CurrentVersion="5.13"

rem PVM
set PVM_Key="HKLM\SOFTWARE\Wow6432Node\NEC\PVM"
set PVM_ProductVersion="6.9.0008"
set PVM_ProductVersion2="6.9.0213"
set PVM_ProductVersion3="6.9.0321"
set PVM_ProductCode="{B4A8A1D2-23AE-4139-A443-DA5ACEE64625}"
set PVM_ProductCode2="{FAC1DDDF-FE3A-4AEF-BD64-1D242ACCCBA0}"
set PVM_ProductCode3="{E435F71A-DAC0-4908-9D79-D9776BD4A85C}"


rem registry check
call :LOOP %ESMPRO_Key% "CurrentVersion" %ESMPRO_CurrentVersion%
call :LOOP %DPM_Key% "VersionInformation" %DPM_VersionInformation%
call :LOOP %Sysmon_Key% "CurrentVersion" %Sysmon_CurrentVersion%

call :LOOP_PVM %PVM_Key% "Version" %PVM_ProductVersion% %PVM_ProductVersion2% %PVM_ProductVersion3% 
call :LOOP_PVM %PVM_Key% "ProductVersion" %PVM_ProductVersion% %PVM_ProductVersion2% %PVM_ProductVersion3%
call :LOOP_PVM %PVM_Key% "ProductCode" %PVM_ProductCode% %PVM_ProductCode2% %PVM_ProductCode3%

pause

goto :eof

:LOOP
reg query %1 /v %2 | find %3

if %ErrorLevel%==0 goto OK
if %ErrorLevel%==1 goto NG

:OK
echo %2 : OK
exit /b :LOOP

:NG
echo %2 : NG
exit /b :LOOP

:LOOP_PVM
@reg query %1 /v %2 | findstr "%3 %4 %5"

if %ErrorLevel%==0 goto OK(PVM)
if %ErrorLevel%==1 goto NG(PVM)

:OK(PVM)
echo %2 : OK
exit /b :LOOP_PVM

:NG(PVM)
echo %2 : NG
exit /b :LOOP_PVM